﻿/*
Copyright (c) 2003-2011, CKSource - Frederico Knabben. All rights reserved.
For licensing, see LICENSE.html or http://ckeditor.com/license
*/

CKEDITOR.editorConfig = function( config )
{
	// Define changes to default configuration here. For example:
	// config.language = 'fr';
	// config.uiColor = '#AADC6E';
	
	// toolbar
	config.toolbar = [
		{ name: 'styles',		items : [ 'PlinnStyles','Format', 'Font', 'FontSize' ] },
		{ name: 'colors',		items : [ 'TextColor', 'BGColor' ] },
		{ name: 'document',		items : [ 'Maximize', 'ShowBlocks', 'Source'] },
		{ name: 'editing',		items : [ 'Find','Replace', '-', 'SelectAll'] },
		{ name: 'clipboard',	items : [ 'PasteFromWord', '-', 'Undo', 'Redo' ] },
		'/',
		{ name: 'basicstyles',	items : [ 'Bold', 'Italic', 'Underline', 'Strike', 'Subscript', 'Superscript', '-', 'RemoveFormat' ] },
		{ name: 'paragraph',	items : [ 'NumberedList', 'BulletedList', '-', 'Outdent', 'Indent', '-', 'Blockquote', 'CreateDiv', '-', 'JustifyLeft', 'JustifyCenter', 'JustifyRight', 'JustifyBlock'] },
		{ name: 'links',		items : [ 'Link', 'Unlink', 'Anchor' ] },
		{ name: 'insert',		items : [ 'PlinnImage', 'Flash', 'Table', 'HorizontalRule', 'SpecialChar', 'PageBreak'] },
	];
	
	// context menu
	config.menu_groups = 'tablecell,tablecellproperties,tablerow,tablecolumn,table,anchor,link,image,flash'
	
	config.height = '500px';
	config.contentsCss = CKEDITOR.basePath + 'global_plinn_style_editor.css';
	config.allowedContent = true;
	
	config.filebrowserBrowseUrl = CKEDITOR.basePath + 'filemanager/browser/mac_finder/browser.html?Connector=connectors/plinn/connector';
	CKEDITOR.config.filebrowserImageBrowseUrl = CKEDITOR.basePath + 'filemanager/browser/mac_finder/browser.html?Type=Image&Connector=connectors/plinn/connector';
	config.filebrowserWindowHeight = 600;
	config.filebrowserWindowWidth = 801;
	config.attachmentBrowserConnectorUrl = CKEDITOR.basePath + 'plugins/plinn_image/connectors/plinn/connector';
	config.imageMaxDefaultDimension = 500 ; // image inserted will be cropped at this size.
	config.extraPlugins = 'plinn_image,plinn_styles,codemirror';

	config.stylesSet = 'plinn_styles:' + CKEDITOR.basePath + 'plinn_ckeditor_styles.js'; 
};